<?php
Class DSTaxMetaData {
	
	private $db = false;
	private $table;
	private $tax_type;
	
	function __construct() {
		global $wpdb;
		$this->db = &$wpdb;
		$this->tax_type = 'kategooriad';
		$this->table = $this->db->prefix . $this->tax_type . 'meta';
		$variable_name = $this->tax_type . 'meta';
		$this->db->$variable_name = $this->table;		
		add_action ( 'kategooriad_edit_form_fields', array(&$this, 'tag_input_metabox' ), 10, 2);
		add_action ( 'edited_kategooriad', array(&$this, 'save_tag_data' ), 10, 2);
	}
	public function install() {
    	include_once ABSPATH . 'wp-content/plugins/ds-taxonomy-meta/installer.php';
    }
    
    public function uninstall() {
    	include_once ABSPATH . 'wp-content/plugins/ds-taxonomy-meta/uninstaller.php';
    }
	function tag_input_metabox($tag, $taxonomy) {
		$image_field = get_metadata($tag->taxonomy, $tag->term_id, 'image_metadata', TRUE);	
		$upload_dir = wp_upload_dir(); 
		?>
		<tr class="form-field">
			<th scope="row" valign="top"><label for="tag_widget"><?php _e('Lae pilt') ?></label></th>
			<td>
			<input type='file' name='tag_meta_input' id='tag_meta_input' value='' />	
			<!-- Display all our meta-data options --> 
			<img src="<?php echo $upload_dir['baseurl'] . '/' . $image_field; ?>" alt="" style="width: 170px; height: 154px;" />
			 </td>
		</tr>
	 
		<?php
	}
 
	function save_tag_data($term_id) {
			if (!$term_id) return;
	        if (isset( $_FILES['tag_meta_input']) && ($_FILES['tag_meta_input']['name'] != '')) {
	        	if ( $_FILES['tag_meta_input']['error'] > 0 ) {
					wp_die( 'Ei saa laadida kategooria pilt:' . $_FILES['tag_meta_input']["error"], 'Error');
				} else {
					$rnd_str = $this->generateRandomStr();
					$upload_dir = wp_upload_dir();
					$filename = $upload_dir['basedir'] . '/' . $rnd_str . basename( $_FILES['tag_meta_input']['name']);
					if( ! move_uploaded_file($_FILES['tag_meta_input']['tmp_name'], $filename)) {
						wp_die('Ei saa panna laaditud pilt', 'Error');
					} else {
						$old_image = $upload_dir['basedir'] . '/' . get_metadata($_POST['taxonomy'], $term_id, 'image_metadata', TRUE);
						if ( ( !is_dir($old_image) ) && file_exists ($old_image) ) unlink( $old_image );
						$new_image = $rnd_str . basename( $_FILES['tag_meta_input']['name']);
						update_metadata($_POST['taxonomy'], $term_id, 'image_metadata', $new_image);
					}
	        	}
	        }
	}
	
	function generateRandomStr($length = 6){
	  $chars = 'abdefhiknrstyzABDEFGHKNQRSTYZ23456789';
	  $numChars = strlen($chars);
	  $string = '';
	  for ($i = 0; $i < $length; $i++) {
	    $string .= substr($chars, rand(1, $numChars) - 1, 1);
	  }
	  return $string;
	}
	
}
?>
